/* utilSlist.h: declarations for singly linked lists (with and without
 * header)
 */

#ifndef UTILSLIST_H
#define UTILSLIST_H

#include "utilGenlist.h"

typedef struct slistStruct
{
  itemType *data;
  struct slistStruct *next;
} slist;

typedef struct
{
  int size;
  slist *first;
  slist *last;
} hslist;


/* ------ PUBLIC INTERFACE FUNCTIONS ------ */

EXTERNC void useFuncsForSlists(
  void *(*mallocFunc)(size_t),
  void (*freeFunc)(void *)
);


EXTERNC slist *createSlist();

EXTERNC void destroySlist(slist *theList);
#define destroySlistPointer(THELISTPTR) \
  destroySlist(THELISTPTR); THELISTPTR = NULL;

EXTERNC slist *addToSlistStart(slist *theList, itemType *data);
#define addToSlistStartPointer(THELISTPTR, DATA) \
  THELISTPTR = addToSlistStart(THELISTPTR, DATA);

EXTERNC int doAllSlist(
  slist *theList,
  int (*itemFunc)(itemType *, char *),
  char *data
);

EXTERNC int sizeOfSlist(slist *theList);
#define isSlistEmpty(SLIST) (SLIST == NULL)  


EXTERNC hslist *createHslist();

EXTERNC void destroyHslist(hslist *theList);
#define destroyHslistPointer(THELISTPTR) \
  destroyHslist(THELISTPTR); THELISTPTR = NULL;

EXTERNC hslist *addToHslistStart(hslist *theList, itemType *data);
#define addToHslistStartPointer(THELISTPTR, DATA) \
  THELISTPTR = addToHslistStart(THELISTPTR, DATA);

#define doAllHslist(HSLIST, FUNC, DATA) \
  (HSLIST == NULL ? 0 : doAllSlist(HSLIST->first, FUNC, DATA))

#define sizeOfHslist(HSLIST) (HSLIST == NULL ? 0 : HSLIST->size)
#define isHslistEmpty(HSLIST) (HSLIST == NULL ? 1 : HSLIST->size == 0)

#endif

